#ifndef __GLASSEXEREGISTRY_H__
#define __GLASSEXEREGISTRY_H__

#include "registry.h"

class GlassExeRegistry : public virtual Registry 
{
 public:

  string humanFileName;
  string mouseFileName;
  string outputFileName;

  bool readParameters;
  string parameterFileName;

  bool useClustalHeader;

  bool outputRegions;

  string glassHeader;
  string clustalHeader;

  GlassExeRegistry() {
    humanFileName = "";
    mouseFileName = "";
    outputFileName = "";
    parameterFileName = "";
    readParameters = false;
    useClustalHeader = false;
    outputRegions = false;
    glassHeader = "GLASS (1.2b) pairwise sequence alignment\n\n\n";
    clustalHeader = "CLUSTAL W (1.81) MULTIPLE SEQUENCE ALIGNMENT\n\n\n";
  };
  //
  // Effects:   Constructs a new GlassExeRegistry with default fields.
  //

  ~GlassExeRegistry() {};

 protected:

  void setFields(const map<string,string>* table);
  //
  // Modifies:  this
  //
  // Effects:   Sets the instance variables of this to the values
  //            given in table. Unrecognized keys are ignored and
  //            fields corresponding to missing keys are not modified.
  //
};

#endif
